Package com.sas.metadata.remote

# Interface PropertySet

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface PropertySet extends SecondaryType
A PropertySet contains a complete set of properties to be used by the OwningObject in a particular context. The properties that are part of this set are associated using the SetProperties association. Additional information regarding the charateristics or context of the PropertySet is modeled using the Properties association. Note that Properties extend the PropertySet and SetProperties are the set of Properties that extend the OwningObject.

Attributes of PropertySet are:

- `SetRole`
- `PropertySetName`

Associations of PropertySet are:

- `OwningObject`
- `SetProperties`

## Usage

To create an instance of this PropertySet, use the `factory` create methods.
Example: create a PropertySet with name "PropertySet_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PropertySet myObject = (PropertySet) factory.createComplexMetadataObject(objectStore, "PropertySet_Object", MetadataObjects.PROPERTYSET, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_OWNINGOBJECT_NAME`
  Constant used for the name of the OwningObject association.
  `static final String`
  `ASSOCIATION_SETPROPERTIES_NAME`
  Constant used for the name of the SetProperties association.
  `static final String`
  `ATTRIBUTE_PROPERTYSETNAME_NAME`
  Constant used for the name of the PropertySetName attribute.
  `static final String`
  `ATTRIBUTE_SETROLE_NAME`
  Constant used for the name of the SetRole attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Root`
  `getOwningObject()`
  Gets the `Root` for `OwningObject`
  `AssociationList`
  `getOwningObjects()`
  Gets the AssociationList of `OwningObjects`
  `AssociationList`
  `getOwningObjects(boolean fGoToServer)`
  Gets the Associationlist of `OwningObjects`
  `String`
  `getPropertySetName()`
  Gets the `String` value of `PropertySetName`
  `int`
  `getPropertySetNameMaxLength()`
  Gets the maximum length of `PropertySetName`
  `int`
  `getPropertySetNameState()`
  Gets the Metadata State of `PropertySetName`
  `AssociationList`
  `getSetProperties()`
  Gets the AssociationList of `SetProperties`
  `AssociationList`
  `getSetProperties(boolean fGoToServer)`
  Gets the Associationlist of `SetProperties`
  `String`
  `getSetRole()`
  Gets the `String` value of `SetRole`
  `int`
  `getSetRoleMaxLength()`
  Gets the maximum length of `SetRole`
  `int`
  `getSetRoleState()`
  Gets the Metadata State of `SetRole`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `OwningObject`
  `SetProperties`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningObject`
  `void`
  `setOwningObject(Root inObject)`
  Sets the `OwningObjects` list 0th element to be `inObject`.
  `void`
  `setOwningObjects(AssociationList list)`
  Sets the `OwningObjects` list to be `list`.
  `void`
  `setOwningObjects(AssociationList list, int state)`
  Sets the `OwningObjects` list to be `list`.
  `void`
  `setPropertySetName(String inPropertySetName)`
  Sets the `PropertySetName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPropertySetName(String inPropertySetName, int state)`
  Sets the `PropertySetName` Metadata State.
  `void`
  `setPropertySetNameState(int state)`
  Sets the Metadata State of `PropertySetName`.
  `void`
  `setSetProperties(AssociationList list)`
  Sets the `SetProperties` list to be `list`.
  `void`
  `setSetProperties(AssociationList inObjects, int state)`
  Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
  `void`
  `setSetRole(String inSetRole)`
  Sets the `SetRole` value and sets the state to MetadataState.LOCAL.
  `void`
  `setSetRole(String inSetRole, int state)`
  Sets the `SetRole` Metadata State.
  `void`
  `setSetRoleState(int state)`
  Sets the Metadata State of `SetRole`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_SETROLE_NAME

    static final String ATTRIBUTE_SETROLE_NAME
    Constant used for the name of the SetRole attribute.

    SetRole: The role identifies the usage of this property set. For example, there may be multiple PropertySet objects for dataset options, for Read, Update, Create. The Role attribute helps identify the usage of the PropertySet.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PROPERTYSETNAME_NAME

    static final String ATTRIBUTE_PROPERTYSETNAME_NAME
    Constant used for the name of the PropertySetName attribute.

    PropertySetName: The name of the property set as used by an application. This name is not localized.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGOBJECT_NAME

    static final String ASSOCIATION_OWNINGOBJECT_NAME
    Constant used for the name of the OwningObject association.

    OwningObject: The object that owns the Property objects in the PropertySet.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_SETPROPERTIES_NAME

    static final String ASSOCIATION_SETPROPERTIES_NAME
    Constant used for the name of the SetProperties association.

    SetProperties: The property objects contained in this set.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningObject`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `OwningObject`
    `SetProperties`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSetRole

    String getSetRole() throws RemoteException
    Gets the `String` value of `SetRole`
    Returns:
      The `SetRole`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSetRoleState

    int getSetRoleState() throws RemoteException
    Gets the Metadata State of `SetRole`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getSetRoleMaxLength

    int getSetRoleMaxLength() throws RemoteException
    Gets the maximum length of `SetRole`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertySetName

    String getPropertySetName() throws RemoteException
    Gets the `String` value of `PropertySetName`
    Returns:
      The `PropertySetName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertySetNameState

    int getPropertySetNameState() throws RemoteException
    Gets the Metadata State of `PropertySetName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPropertySetNameMaxLength

    int getPropertySetNameMaxLength() throws RemoteException
    Gets the maximum length of `PropertySetName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOwningObjects

    AssociationList getOwningObjects() throws RemoteException, MdException
    Gets the AssociationList of `OwningObjects`
    Returns:
      Returns the AssociationList of `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningObject

    Root getOwningObject() throws RemoteException, MdException
    Gets the `Root` for `OwningObject`
    Returns:
      The `Root` ( `null` if not set) of `OwningObject`which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSetProperties

    AssociationList getSetProperties() throws RemoteException, MdException
    Gets the AssociationList of `SetProperties`
    Returns:
      Returns the AssociationList of `SetProperties` which can be of type:
      Property
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningObjects

    AssociationList getOwningObjects(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningObjects`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningObjects` which can be of type:
      All types
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getSetProperties

    AssociationList getSetProperties(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `SetProperties`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `SetProperties` which can be of type:
      Property
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setSetRole

    void setSetRole(String inSetRole) throws RemoteException
    Sets the `SetRole` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inSetRole` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSetRole

    void setSetRole(String inSetRole, int state) throws RemoteException
    Sets the `SetRole` Metadata State.
    Parameters:
      `inSetRole` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSetRoleState

    void setSetRoleState(int state) throws RemoteException
    Sets the Metadata State of `SetRole`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertySetName

    void setPropertySetName(String inPropertySetName) throws RemoteException
    Sets the `PropertySetName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPropertySetName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertySetName

    void setPropertySetName(String inPropertySetName, int state) throws RemoteException
    Sets the `PropertySetName` Metadata State.
    Parameters:
      `inPropertySetName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPropertySetNameState

    void setPropertySetNameState(int state) throws RemoteException
    Sets the Metadata State of `PropertySetName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObjects

    void setOwningObjects(AssociationList list, int state) throws RemoteException
    Sets the `OwningObjects` list to be `list`. Object of which can be of type:
    All types
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningObject

    void setOwningObject(Root inObject) throws RemoteException
    Sets the `OwningObjects` list 0th element to be `inObject`.
    Parameters:
      `inObject` - Root
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSetProperties

    void setSetProperties(AssociationList list) throws RemoteException
    Sets the `SetProperties` list to be `list`. Objects of which can be of type:
    Property
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setSetProperties

    void setSetProperties(AssociationList inObjects, int state) throws RemoteException
    Sets the entire AssociationList to match the passed in Vector, sets the state of the AssociationList
    Parameters:
      `inObjects` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.